package com.logicbig.example;

import org.springframework.beans.BeanWrapperImpl;
import java.util.ArrayList;
import java.util.HashMap;

public class BeanWrapperNestedIndexProperty {
    public static void main(String[] args) {
        BeanWrapperImpl bw = new BeanWrapperImpl(new EmployeeGroup());
        bw.setPropertyValue("groupName", "TennisTeam");
        bw.setPropertyValue("employeeList", new ArrayList<>());

        bw.setPropertyValue("employeeList[0]", new Employee());
        bw.setPropertyValue("employeeList[0].name", "Mike");
        bw.setPropertyValue("employeeList[0].department", new Department());
        bw.setPropertyValue("employeeList[0].department.deptCode", 1001);
        bw.setPropertyValue("employeeList[0].department.deptName", "Admin");

        bw.setPropertyValue("employeeList[1]", new Employee());
        bw.setPropertyValue("employeeList[1].name", "Jackie");
        bw.setPropertyValue("employeeList[1].department", new Department());
        bw.setPropertyValue("employeeList[1].department.deptCode", 1002);
        bw.setPropertyValue("employeeList[1].department.deptName", "Account");

        bw.setPropertyValue("groupProperties", new HashMap<>());
        bw.setPropertyValue("groupProperties[location]", "Texas");
        bw.setPropertyValue("groupProperties[matchesPerYear]", "2");

        System.out.println(bw.getWrappedInstance());

        System.out.println("-- accessing field values --");
        Object employeeList = bw.getPropertyValue("employeeList");
        System.out.println("employeeList: " + employeeList);
        Object firstEmployee = bw.getPropertyValue("employeeList[0]");
        System.out.println("employeeList[0]: " + firstEmployee);
        Object firstEmployeeDept = bw.getPropertyValue("employeeList[0].department.deptName");
        System.out.println("employeeList[0].department.deptName: " + firstEmployeeDept);
        Object matchesPerYear = bw.getPropertyValue("groupProperties[matchesPerYear]");
        System.out.println("groupProperties[matchesPerYear]: "+matchesPerYear);
    }
}